#
# This is an albatross-specific driver for the Sphinx LaTeX to ReST converter
# that can be found at:
#
#    http://svn.python.org/projects/doctools/converter
#
import sys, os
sys.path.insert(0, '/usr/src/py/sphinx/converter')
from converter import convert_file, restwriter
from converter.latexparser import ParserError
from converter.restwriter import WriterError

os.chdir('newdoc')
source = '../doc'

# The converter was built for converting the Python docs, and contains
# extensive logic to reorganise the file structure. We mostly knobble this here
# by monkey-patching their hard-coded mappings:
class IncludeRewrite:
    def get(self, a, b=None):
        if os.path.exists(os.path.join(source, a + '.tex')):
            return a + '.rst'
        return a
restwriter.includes_mapping = IncludeRewrite()

exceptions = (ParserError,WriterError)

for fn in os.listdir(source):
    if fn.endswith('.tex'):
        infile = os.path.join(source, fn)
        outfile = fn[:-4] + '.rst'
        success, state = convert_file(infile, outfile, doraise=False)
        if not success:
            print "ERROR:"
            print "    " + state
        else:
            if state:
                print "warnings:"
                for warning in state:
                    print "    " + warning
