from albatross.ext.form import *
from contact import ContactDatabase, Contact
from form import ContactForm


def page_enter(ctx):
    if not ctx.has_value('contacts_form'):
        ctx.redirect('contacts')
    if not ctx.has_value('add_contact_form'):
        ctx.locals.add_contact_form = ContactForm('Add contact')
        ctx.add_session_vars('add_contact_form')
    ctx.locals.add_contact_form.clear()


def page_process(ctx):
    if ctx.req_equals('save_contact'):
        try:
            ctx.locals.add_contact_form.validate()
        except FormValidationError:
            return
        db = ContactDatabase()
        contact = db.fetch_empty_row(Contact)
        ctx.locals.add_contact_form.merge(contact)
        contact.save(db)
        db.commit()
        ctx.locals.contacts_form.contacts_table.append(contact)
        ctx.redirect('contacts')
    elif ctx.req_equals('cancel_contact'):
        ctx.redirect('contacts')


def page_display(ctx):
    ctx.run_template('add_contact.html')
