from contact import ContactDatabase
from form import ContactsForm


def page_enter(ctx):
    if not ctx.has_value('contacts_form'):
        ctx.locals.contacts_form = ContactsForm()
        ctx.locals.delete_contacts = None
        ctx.add_session_vars('contacts_form', 'delete_contacts')


def page_process(ctx):
    if ctx.req_equals('delete_selected'):
        table = ctx.locals.contacts_form.contacts_table
        ctx.locals.delete_contacts = []
        for i, row in enumerate(table.current_page_items):
            if row.delete.get_value():
                ctx.locals.delete_contacts.append(
                    (row, table.pager.get_child(i)))
        if ctx.locals.delete_contacts:
            ctx.locals.contacts_form.set_disabled(True)
    elif ctx.req_equals('confirm_delete'):
        db = ContactDatabase()
        table = ctx.locals.contacts_form.contacts_table
        for row, contact in ctx.locals.delete_contacts:
            contact.delete(db)
        db.commit()
        table.load_page()
        ctx.locals.delete_contacts = None
        ctx.locals.contacts_form.set_disabled(False)
    elif ctx.req_equals('add_contact'):
        ctx.redirect('add_contact')
    else:
        if ctx.locals.delete_contacts:
            ctx.locals.delete_contacts = None
            table = ctx.locals.contacts_form.contacts_table
            for row in table.current_page_items:
                row.delete.set_value(False)
        ctx.locals.contacts_form.set_disabled(False)


def page_display(ctx):
    ctx.run_template('contacts.html')
