from albatross.ext.form import *
from contact import ContactDatabase, Contact
from form import ContactForm


def page_enter(ctx):
    if not ctx.has_value('contacts_form'):
        ctx.redirect('contacts')
    if not ctx.has_value('edit_contact_form'):
        ctx.locals.edit_contact_form = ContactForm('Edit contact')
        ctx.add_session_vars('edit_contact_form')
    ctx.merge_vars('contact_id')
    if ctx.has_value('contact_id'):
        db = ContactDatabase()
        ctx.locals.edit_contact = db.fetch_one(
            row_class=Contact, id=ctx.locals.contact_id)
        ctx.add_session_vars('edit_contact')
        ctx.locals.edit_contact_form.load(ctx.locals.edit_contact)
    elif not ctx.has_value('edit_contact'):
        ctx.redirect('contacts')


def page_process(ctx):
    if ctx.req_equals('save_contact'):
        try:
            ctx.locals.edit_contact_form.validate()
        except FormValidationError:
            return
        db = ContactDatabase()
        ctx.locals.edit_contact_form.merge(ctx.locals.edit_contact)
        ctx.locals.edit_contact.save(db)
        db.commit()
        ctx.locals.contacts_form.contacts_table.load_page()
        ctx.del_session_vars('edit_contact')
        ctx.redirect('contacts')
    elif ctx.req_equals('cancel_contact'):
        ctx.del_session_vars('edit_contact')
        ctx.redirect('contacts')


def page_display(ctx):
    ctx.run_template('edit_contact.html')
